#include <stdio.h>
#include <math.h>
#include <string.h>

#define N 100

void Bin2Dec();
void Oct2Dec();
void Hex2Dec();
void Dec2Bin();
void Dec2Oct();
void Dec2Hex();

int main()
{
	int choice;
	do
	{
		printf("Enter your choice\n");
		printf("1. Binary to Decimal\n");
		printf("2. Octal to Decimal\n");
		printf("3. Hex to Decimal\n");
		printf("4. Decimal to Binary\n");
		printf("5. Decimal to Octal\n");
		printf("6. Decimal to Hex\n");
		printf("0 to Exit\n");
		scanf("%d",&choice);
		switch(choice)
		{
		case 1:
			Bin2Dec();
			break;
		case 2:
			Oct2Dec();
			break;
		case 3:
			Hex2Dec();
			break;
		case 4:
			Dec2Bin();
			break;
		case 5:
			Dec2Oct();
			break;
		case 6:
			Dec2Hex();
			break;
		}
	}while(choice);
	
	return choice;
}

void Bin2Dec()
{
	int bin,n,r,s=0,i;
	printf("Enter a binary number\n");
	scanf("%d",&bin);
	n=bin;
	for(i=0;n!=0;i++)
	{
		r=n%10;
		s=s+r*(int)pow(2,i);
		n=n/10;
	}
	printf("The equivalent number of %d is %d\n",bin,s);
}

void Oct2Dec()
{
	int oct,n,r,s=0,i;
	printf("Enter an octal number\n");
	scanf("%d",&oct);
	n=oct;
	for(i=0;n!=0;i++)
	{
		r=n%10;
		s=s+r*(int)pow(8,i);
		n=n/10;
	}
	printf("The equivalent number of %d is %d\n",oct,s);
}

void Hex2Dec()
{
	char hex[N];
	int i,j,n[N],l;
	long double dec=0;
	printf("Enter the hexa decimal number and find it's decimal equivalent\n");
	fflush(stdin);
	gets(hex);
	l=strlen(hex);
	for(i=0;i<l;i++)
	{
		switch(hex[i])
		{
		case '0':
			n[i]=hex[i]-48;     //Ascii code of 0 is 48  48-48=0//
			break;
		case '1':
			n[i]=hex[i]-48;		//Ascii code of 1 is 49  49-48=1//
			break;
		case '2':
			n[i]=hex[i]-48;		//Ascii code of 2 is 50  50-48=2//
			break;
		case '3':
			n[i]=hex[i]-48;		//Ascii code of 3 is 51  51-48=3//
			break;
		case '4':
			n[i]=hex[i]-48;		//Ascii code of 4 is 52  52-48=4//
			break;
		case '5':
			n[i]=hex[i]-48;		//Ascii code of 5 is 53  53-48=5//
			break;
		case '6':
			n[i]=hex[i]-48;		//Ascii code of 6 is 54  54-48=6//
			break;
		case '7':
			n[i]=hex[i]-48;		//Ascii code of 7 is 55  55-48=7//
			break;
		case '8':
			n[i]=hex[i]-48;		//Ascii code of 8 is 56  56-48=8//
			break;
		case '9':
			n[i]=hex[i]-48;		//Ascii code of 9 is 57  57-48=9//
			break;
		case 'A':
			n[i]=hex[i]-55;     //Ascii code of A is 65 65-55=10//
			break;
		case 'B':
			n[i]=hex[i]-55;		//Ascii code of B is 65 66-55=11//
			break;
		case 'C':
			n[i]=hex[i]-55;		//Ascii code of C is 65 67-55=12//
			break;
		case 'D':
			n[i]=hex[i]-55;		//Ascii code of D is 65 68-55=13//
			break;
		case 'E':
			n[i]=hex[i]-55;		//Ascii code of E is 65 68-55=14//
			break;
		case 'F':
			n[i]=hex[i]-55;		//Ascii code of F is 65 69-55=15//
			break;
		}
	}
	for(i=0,j=l;i<l;i++,j--)
		dec=dec+(n[j-1]*pow(16,i));
	printf("The decimal equivalent is %lg \n",dec);
}

void Dec2Oct()
{
	int n,r[10],i;
	printf("Enter a number to find it's octal equivalent\n");
	scanf("%d",&n);
	printf("The octal equivalent of %d is ",n);
	for(i=0;n!=0;i++)
	{
		r[i]=n%8;
		n=n/8;
	}
	i--;
	for(;i>=0;i--)
		printf("%d",r[i]);
	printf("\n");
}

void Dec2Hex()
{
	int n,r[10],i;
	printf("Enter a number to get its hexadecimal equivalent\n");
	scanf("%d",&n);
	for(i=0;n!=0;i++)
	{
		r[i]=n%16;
		n=n/16;
	}
	i--;
	for(;i>=0;i--)
	{
		if(r[i]==10)
			printf("A");
		else if(r[i]==11)
			printf("B");
		else if(r[i]==12)
			printf("C");
		else if(r[i]==13)
			printf("D");
		else if(r[i]==14)
			printf("E");
		else if(r[i]==15)
			printf("F");
		else
			printf("%d",r[i]);
	}
	printf("\n");
}

void Dec2Bin()
{
	int n,bin[100],i,j;
	printf("Enter A Number To Find It's Binary Equivalence\n");
	scanf("%d",&n);
	printf("The Binary Equivalent of %d is \t",n);
	for(i=0;n!=0;i++)
	{
		bin[i]=n%2;
		n=n/2;
	}
	for(j=i-1;j>=0;j--)
	{
		printf("%d",bin[j]);
	}
	printf("\n");
}
